package neoseo.kickbot;

public interface Kicker {
	// Kicking a ball to the LEFT side of the goal
	public static final int LEFT = 0;

	// Kicking a ball to the RIGHT side of the goal
	public static final int RIGHT = 1;

	// Only 2 directions you can choose - LEFT, RIGHT
	public static final int NUM_OF_DIRECTIONS = 2;

	/**
	 * Returns the name of the algorithm. 
	 * @return Algorithm name
	 */
	public String getName();
	
	/**
	 * Initializes bot and makes the first kick of the game.
	 * @return The direction you want to kick to - LEFT(0) or RIGHT(1)
	 */
	public int kickAtFirst();

	/**
	 * Makes a decision(LEFT or RIGHT) according to the previous result.
	 * If prevKeeperDirection is out of bound, it initializes bot and makes the first kick of the game.
	 * @param prevKeeperDirection  The direction keeper dived to in the previous kick. 
	 * @return The direction you want to kick to - LEFT(0) or RIGHT(1)
	 * @throws Exception
	 */
	public int kick(int prevKeeperDirection);
}
