package neoseo.kickbot;

/**
 * @title Kickbot Stadium
 * @version 1.0.2
 * @author neoseo4535@hotmail.com
 * First Release: 2010.10.04
 * Last Update: 2010.11.01 00:00
 * 
 * Design your own bot in class MyKicker.
 */
public class MiniStadium {

	// How many kicks are made in a game.
	public static final int NUM_OF_KICKS = 999;  // 500 goals to win

	/**
	 * @param args
	 * @throws Exception 
	 */
	public static void main(String[] args) throws Exception {
		// Initialize a game.
		Kicker kicker = new MyKicker();
		Kicker keeper = new NotMyKicker();  // kicker AI can be used as keeper AI.
		int nGoal = 0;
		System.out.println("Kickbot Stadium v1.0.2");
		System.out.println("Kicker " + kicker.getName() + " vs. Keeper " + keeper.getName());

		// Loop 999 kicks
		int choiceKicker = -1, choiceKeeper = -1;
		int prevKickerDirection = -1, prevKeeperDirection = -1;
		for (int iKick = 0; iKick < NUM_OF_KICKS; iKick++)
		{
			// Kicker kicks the ball. At the same time, Keeper dives.
			prevKickerDirection = choiceKicker;
			prevKeeperDirection = choiceKeeper;
			choiceKicker = kicker.kick(prevKeeperDirection);
			choiceKeeper = keeper.kick(1 - prevKickerDirection);  // kicker AI can be used as keeper AI in this way.

			// Check validity of the bot outputs.
			if (!isDirection(choiceKicker) || !isDirection(choiceKeeper))
				throw new Exception();
			
			// If the ball is directed to the opposite of the Keeper, it is a goal.
			boolean isGoal = (choiceKicker != choiceKeeper);
			if (isGoal) nGoal++;
			System.out.println(choiceKicker + " " + choiceKeeper + " " + (isGoal? "Goal!" : "Save"));
		}

		// Display the result.
		System.out.println(NUM_OF_KICKS + " Kicks, " + nGoal + " Goals");
		if (NUM_OF_KICKS/2 < nGoal)
			System.out.println("Kicker win!");
		else
			System.out.println("Keeper win!");
	}

	private static boolean isDirection(int digit)
	{
		return ( 0 <= digit && digit < Kicker.NUM_OF_DIRECTIONS );
	}
}
